# -*- coding: utf-8 -*-
"""
	Hawk Add-on
"""

from resources.lib.modules.control import addonPath, addonId, gethawkVersion, joinPath
from resources.lib.windows.textviewer import TextViewerXML


def get(file):
	hawk_path = addonPath(addonId())
	hawk_version = gethawkVersion()
	helpFile = joinPath(hawk_path, 'resources', 'help', file + '.txt')
	f = open(helpFile, 'r', encoding='utf-8', errors='ignore')
	text = f.read()
	f.close()
	heading = '[B]hawk -  v%s - %s[/B]' % (hawk_version, file)
	windows = TextViewerXML('textviewer.xml', hawk_path, heading=heading, text=text)
	windows.run()
	del windows
