# -*- coding: utf-8 -*-
"""
	All Accounts
"""

from allaccounts.modules.control import addonPath, addonVersion, joinPath
from allaccounts.windows.textviewer import TextViewerXML
from allaccounts.modules import py_tools

if py_tools.isPY2:
	from io import open #py2 open() does not support encoding param

def get(file):
	allaccounts_path = addonPath()
	allaccounts_version = addonVersion()
	helpFile = joinPath(allaccounts_path, 'lib', 'allaccounts', 'help', file + '.txt')
	r = open(helpFile, 'r', encoding='utf-8', errors='ignore')
	text = r.read()
	r.close()
	heading = '[B]All Accounts -  v%s - %s[/B]' % (allaccounts_version, file)
	windows = TextViewerXML('textviewer.xml', allaccounts_path, heading=heading, text=text)
	windows.run()
	del windows