import time
import xbmc
import os
import xbmcgui
import webbrowser


def menuoptions():
    dialog = xbmcgui.Dialog()
    funcs = (
        function1,
        function2,
        function3,
        function4,
        function5,
        function6,
        function7,
        function8,
        function9,
        function10,
        function11, 
        function12, 
        function13,
        )
        
    call = dialog.select('[B][COLOR=dodgerblue]Navyseal Browser Channels - Mouse Mode May be Needed on Some Sites[/COLOR][/B]', [
	'[B][COLOR=aqua]     Movie-Web - Movies[/COLOR][/B]',
    '[B][COLOR=aqua]     Movie-Web - TV Shows[/COLOR][/B]',
    '[B][COLOR=aqua]     Google[/COLOR][/B]',
    '[B][COLOR=aqua]     Blaze TV UK[/COLOR][/B]',
    '[B][COLOR=aqua]     USTVGO TV[/COLOR][/B]',
    '[B][COLOR=aqua]     Aliunde18.9 Fork[/COLOR][/B]',
    '[B][COLOR=aqua]     YouTube Main[/COLOR][/B]',
	'[B][COLOR=aqua]     YouTube Music[/COLOR][/B]',
    '[B][COLOR=aqua]     Classic Cinema Onine[/COLOR][/B]',
    '[B][COLOR=aqua]     Index of Apps[/COLOR][/B]',
    '[B][COLOR=aqua]     Uncle Earls Classic TV[/COLOR][/B]',
    '[B][COLOR=aqua]     News 12 New York[/COLOR][/B]',
    '[B][COLOR=aqua]     Downloader by AFTVnews v1.4.3[/COLOR][/B]',])
    # dialog.selectreturns
    #   0 -> escape pressed
    #   1 -> first item
    #   2 -> second item
    if call:
        # esc is not pressed
        if call < 0:
            return
        func = funcs[call-13]
        return func()
    else:
        func = funcs[call]
        return func()
    return 

def platform():
    if xbmc.getCondVisibility('system.platform.android'):
        return 'android'
    elif xbmc.getCondVisibility('system.platform.linux'):
        return 'linux'
    elif xbmc.getCondVisibility('system.platform.windows'):
        return 'windows'
    elif xbmc.getCondVisibility('system.platform.osx'):
        return 'osx'
    elif xbmc.getCondVisibility('system.platform.atv2'):
        return 'atv2'
    elif xbmc.getCondVisibility('system.platform.ios'):
        return 'ios'

myplatform = platform()

def function1():
    if myplatform == 'android': # Android 
        opensite = xbmc.executebuiltin( 'StartAndroidActivity(,android.intent.action.VIEW,,%s)' % ( 'https://movie-web.app/search/movie' ) )
    else:
        opensite = webbrowser . open('https://movie-web.app/search/movie')
        
def function2():
    if myplatform == 'android': # Android 
        opensite = xbmc.executebuiltin( 'StartAndroidActivity(,android.intent.action.VIEW,,%s)' % ( 'https://movie-web.app/search/series' ) )
    else:
        opensite = webbrowser . open('https://movie-web.app/search/series')

def function3():
    if myplatform == 'android': # Android 
        opensite = xbmc.executebuiltin( 'StartAndroidActivity(,android.intent.action.VIEW,,%s)' % ( 'https://www.google.com/' ) )
    else:
        opensite = webbrowser . open('https://www.google.com/')
        
def function4():
    if myplatform == 'android': # Android 
        opensite = xbmc.executebuiltin( 'StartAndroidActivity(,android.intent.action.VIEW,,%s)' % ( 'https://www.blaze.tv/' ) )
    else:
        opensite = webbrowser . open('https://www.blaze.tv/')
        
def function5():
    if myplatform == 'android': # Android 
        opensite = xbmc.executebuiltin( 'StartAndroidActivity(,android.intent.action.VIEW,,%s)' % ( 'https://tv.ustvgo.live/' ) )
    else:
        opensite = webbrowser . open('https://tv.ustvgo.live/')

def function6():
    if myplatform == 'android': # Android 
        opensite = xbmc.executebuiltin( 'StartAndroidActivity(,android.intent.action.VIEW,,%s)' % ( 'https://go.aftvnews.com/60079/' ) )
    else:
        opensite = webbrowser . open('https://go.aftvnews.com/60079/')

def function7():
    if myplatform == 'android': # Android 
        opensite = xbmc.executebuiltin( 'StartAndroidActivity(,android.intent.action.VIEW,,%s)' % ( 'https://www.youtube.com/' ) )
    else:
        opensite = webbrowser . open('https://www.youtube.com/')

def function8():
    if myplatform == 'android': # Android 
        opensite = xbmc.executebuiltin( 'StartAndroidActivity(,android.intent.action.VIEW,,%s)' % ( 'https://music.youtube.com/' ) )
    else:
        opensite = webbrowser . open('https://music.youtube.com/')

def function9():
    if myplatform == 'android': # Android 
        opensite = xbmc.executebuiltin( 'StartAndroidActivity(,android.intent.action.VIEW,,%s)' % ( 'https://classiccinemaonline.com/' ) )
    else:
        opensite = webbrowser . open('https://classiccinemaonline.com/')

def function10():
    if myplatform == 'android': # Android 
        opensite = xbmc.executebuiltin( 'StartAndroidActivity(,android.intent.action.VIEW,,%s)' % ( 'https://zeno1.site/apps/' ) )
    else:
        opensite = webbrowser . open('https://zeno1.site/apps/')

def function11():
    if myplatform == 'android': # Android 
        opensite = xbmc.executebuiltin( 'StartAndroidActivity(,android.intent.action.VIEW,,%s)' % ( ' https://www.solie.org/ClassicTV/' ) )
    else:
        opensite = webbrowser . open(' https://www.solie.org/ClassicTV/')

def function12():
    if myplatform == 'android': # Android 
        opensite = xbmc.executebuiltin( 'StartAndroidActivity(,android.intent.action.VIEW,,%s)' % ( 'https://tubitv.com/live/557345/news-12-new-york' ) )
    else:
        opensite = webbrowser . open('https://tubitv.com/live/557345/news-12-new-york') 

def function13():
    if myplatform == 'android': # Android 
        opensite = xbmc.executebuiltin( 'StartAndroidActivity(,android.intent.action.VIEW,,%s)' % ( 'https://zeno1.site/dl/' ) )
    else:
        opensite = webbrowser . open('https://zeno1.site/dl/')         
 
menuoptions()
