# -*- coding: utf-8 -*-
"""
	All Accounts
"""

from allaccounts.modules.control import addonPath, addonVersion, joinPath
from allaccounts.windows.textviewer import TextViewerXML
from allaccounts.modules import py_tools

if py_tools.isPY2:
	from io import open #py2 open() does not support encoding param

def get():
	allaccounts_path = addonPath()
	allaccounts_version = addonVersion()
	changelogfile = joinPath(allaccounts_path, 'changelog.txt')
	r = open(changelogfile, 'r', encoding='utf-8', errors='ignore')
	text = r.read()
	r.close()
	heading = '[B]All Accounts -  v%s - ChangeLog[/B]' % allaccounts_version
	windows = TextViewerXML('textviewer.xml', allaccounts_path, heading=heading, text=text)
	windows.run()
	del windows